###########################################################################
# ECR
###########################################################################

resource "aws_ecr_repository" "ecr" {
  name  = "${var.client}/${var.envname}-signalfx-agent"
}

data "aws_iam_policy_document" "ecr_policy" {
  statement {
    actions = [ 
      "ecr:arn:aws:ecr:region:${data.aws_caller_identity.current.account_id}:repository/${var.client}/${var.envname}-signalfx-agent",
    ]

    principals {
      type = "AWS"

      identifiers = [
        "arn:aws:iam::${data.aws_caller_identity.current.account_id}:root",
      ]
    }
  }
}


resource "aws_ecr_repository_policy" "allow_prod" {
  repository = aws_ecr_repository.ecr.name
  policy     = data.aws_iam_policy_document.ecr_policy.json
}



############################################################################
## SignalFx ECR  (cross account sharing policy)
############################################################################
#
#resource "aws_ecr_repository_policy" "ecr" {
#  repository = aws_ecr_repository.ecr.name
#
#  policy = <<EOF
#{
#    "Version": "2008-10-17",
#    "Statement": [
#        {
#            "Sid": "new policy",
#            "Effect": "Allow",
#            "Principal": "*",
#            "Action": [
#                "ecr:GetDownloadUrlForLayer",
#                "ecr:BatchGetImage",
#                "ecr:BatchCheckLayerAvailability",
#                "ecr:PutImage",
#                "ecr:InitiateLayerUpload",
#                "ecr:UploadLayerPart",
#                "ecr:CompleteLayerUpload",
#                "ecr:DescribeRepositories",
#                "ecr:GetRepositoryPolicy",
#                "ecr:ListImages",
#                "ecr:DeleteRepository",
#                "ecr:BatchDeleteImage",
#                "ecr:SetRepositoryPolicy",
#                "ecr:DeleteRepositoryPolicy"
#            ]
#        }
#    ]
#}
#EOF
#}
#
#
#
#
#
#resource "aws_ecr_repository_policy" "ecs_policy" {
#  repository = "${var.envname}/${var.client}/${var.envname}-signalfx"
#  policy     = data.aws_iam_policy_document.ecr_policy.json
#}
#